package cn.com.infosec.crypto.engines;

import cn.com.infosec.crypto.AsymmetricBlockCipher;
import cn.com.infosec.crypto.CipherParameters;

public class RSAEngine implements AsymmetricBlockCipher {
   private RSACoreEngine core;

   public void init(boolean forEncryption, CipherParameters param) {
      if (this.core == null) {
         RSACoreEngine var3;
         var3 = new RSACoreEngine.<init>();
         this.core = var3;
      }

      this.core.init(forEncryption, param);
   }

   public int getInputBlockSize() {
      return this.core.getInputBlockSize();
   }

   public int getOutputBlockSize() {
      return this.core.getOutputBlockSize();
   }

   public byte[] processBlock(byte[] in, int inOff, int inLen) {
      RSACoreEngine var4;
      if ((var4 = this.core) != null) {
         return var4.convertOutput(var4.processBlock(var4.convertInput(in, inOff, inLen)));
      } else {
         throw new IllegalStateException("RSA engine not initialised");
      }
   }
}
